document.addEventListener('DOMContentLoaded', () => {
  const dfMessenger = document.querySelector('df-messenger');
  dfMessenger.addEventListener('df-messenger-loaded', () => {
    // Add privacy link.ƒ
    const titleBarElement = document
      .querySelector('df-messenger')
      .shadowRoot.querySelector('df-messenger-chat')
      .shadowRoot.querySelector('df-messenger-titlebar').shadowRoot.children[1]
      .children[0];
    let privacyLink = document.createElement('a');
    privacyLink.innerHTML = 'Datenschutz';
    privacyLink.href = 'https://www.brk.de/service/datenschutz.html';
    privacyLink.target = '_blank';
    privacyLink.style.padding = '0';
    privacyLink.style.paddingTop = '2';
    privacyLink.style.margin = '0';
    privacyLink.style.color = '#ffffff99';
    privacyLink.style.fontSize = '0.6em';
    privacyLink.style.textDecoration = 'none';
    privacyLink.style.display = 'block';
    titleBarElement.appendChild(privacyLink);

    // update df-messenger-titlebar element
    const titleBarShadow = document
      .querySelector('df-messenger')
      .shadowRoot.querySelector('df-messenger-chat')
      .shadowRoot.querySelector('df-messenger-titlebar').shadowRoot;
    const titleBarShadowChildNodes = Array.from(titleBarShadow.childNodes);
    titleBarShadowChildNodes.forEach((childNode) => {
      if (childNode.nodeName === 'STYLE') {
        // console.log(childNode.textContent);
        childNode.textContent = `
        .title-wrapper {
          align-items: center;
              background-color: #42A5F5;
              background-color: var(--df-messenger-button-titlebar-color);
              border-radius: 5px 5px 0 0;
              box-shadow: 0px 3px 6px 0px #00000029;
              color: white;
              color: var(--df-messenger-button-titlebar-font-color);
              display: flex;
              font-family: 'Roboto', sans-serif;
              font-size: 18px;
              height: 50px;
              justify-content: space-between;
              padding-left: 15px;
        }
        
        #minimizeIcon {
          fill: white;
              fill: var(--df-messenger-button-titlebar-font-color);
              margin: 15px;
              transform: rotate(90deg);
        }
        
        // @media screen and (min-width: 501px) and (min-height: 601px) {
        // #minimizeIcon {
        //   visibility: hidden;
        // }
        
        }
        `;
      }
    });

    // update df-messenger element
    const dfMessengerShadow = document.querySelector('df-messenger').shadowRoot;
    const dfMessengerShadowChildNodes = Array.from(
      dfMessengerShadow.childNodes
    );
    dfMessengerShadowChildNodes.forEach((childNode) => {
      if (childNode.nodeName === 'STYLE') {
        // console.log(childNode.textContent);
        childNode.textContent = `
        .df-messenger-wrapper {
          background-color: white;
              border: 0;
              bottom: 20px;
              color: rgba(0,0,0,0.87);
              font-family: 'Roboto', sans-serif;
              font-size: 14px;
              font-weight: normal;
              margin: 0;
              padding: 0;
              position: fixed;
              right: 76px; // 20px
              text-decoration: none;
              z-index: 100000;
        }
        
        .df-messenger-wrapper a, .df-messenger-wrapper button {
          cursor: pointer;
        }
        
        .df-messenger-wrapper svg {
          fill: rgba(0,0,0,0.87);
              margin: 0;
              padding: 0;
        }
        
        .df-messenger-wrapper img {
          border: 0;
              margin: 0;
              padding: 0;
        }
        
        button#widgetIcon {
              background: #42A5F5;
              background: var(--df-messenger-button-titlebar-color);
              border: none;
              border-radius: 50%;
              bottom: 0px;
              box-shadow: rgba(0, 0, 0, 0.24) 1px 4px 15px 0px;
              cursor: pointer;
              height: 56px;
              position: absolute;
              right: 0px;
              width: 56px;
        }
        
        button#widgetIcon:focus {
          outline-width: 0;
        }
        
        button#widgetIcon .df-chat-icon {
          width: 50px;
          height: 50px;
          top: 3px;
          left: 3px;
          opacity: 1;
          position: absolute;
          transition: opacity 0.5s;
        }
        
        button#widgetIcon .df-chat-icon.hidden {
          opacity: 1; // changed from 0 to 1
        }
        
        button#widgetIcon div.rotate-fade #closeSvg {
          opacity: 0; // change from 1 to 0
          transform: rotate(-90deg);
        }
        
        button#widgetIcon div #closeSvg {
          fill: white;
          fill: var(--df-messenger-button-titlebar-font-color);
          left: 15px;
          opacity: 0;
          position: absolute;
          top: 15px;
          transition: transform 0.5s, opacity 0.5s;
        }
        
        button#widgetIcon .df-chat-icon.default {
          display: none;
        }
        
        button#widgetIcon .df-chat-icon.default.show {
          display: initial;
        }
        
        @media screen and (max-width: 500px), screen and (max-height: 600px) {
        .expanded > #widgetIcon {
          visibility: hidden;
        }
        
        }
        
        @media screen and (min-width: 501px) and (min-height: 601px) {
        .expanded > #widgetIcon {
          visibility: visible;
        }
        
        }
        
        .cls-1 {
          clip-path: url(#clip-path);
        }
        
        .cls-2 {
          fill: #ef6c00;
        }
        
        .cls-3 {
          fill: #ff9800;
        }
        
        .cls-4 {
          fill: #bf360c;
        }
        
        .cls-4, .cls-5 {
          opacity: 0.1;
        }
        
        .cls-5 {
          fill: #fff;
        }
        `;
      }
    });

    // update df-messenger-chat element
    const shadow = document
      .querySelector('df-messenger')
      .shadowRoot.querySelector('df-messenger-chat').shadowRoot;
    const ChatChildNodes = Array.from(shadow.childNodes);

    ChatChildNodes.forEach((childNode) => {
      if (childNode.nodeName === 'STYLE') {
        // console.log(childNode.textContent);
        childNode.textContent = `
        div.chat-wrapper {
            background-color: #e5e5e5;
                border-radius: 4px;
                bottom: 105px;
                box-shadow: rgba(0, 0, 0, 0.24) 1px 4px 15px 0px;
                display: flex;
                flex-direction: column;
                height: 0;
                opacity: 0;
                position: fixed;
                right: 76px; // 20px
                transform: translateX(25%) translateY(35%) scale(0.5, 0.5);
                transition: transform 0.2s ease, opacity 0.2s ease-in, height 0s ease 0.2s;
                width: 370px;
                overflow: hidden;
          }
          
          div.chat-min {
            background-color: #fafafa;
                bottom: 20px;
                height: 0;
                max-width: 370px;
                right: 156px; // 100px
                width: auto;
          }
          
          div.chat-wrapper.chat-min[opened="true"] {
            height: auto;
          }
          
          div.chat-wrapper[opened="true"] {
            height: 500px;
                opacity: 1;
                transform: translate3d(0px, 0px, 0px) scale(1, 1);
                transition: transform 0.2s ease, opacity 0.2s ease-in;
          }
          
          div.chat-min df-message-list {
            background-color: #fafafa;
                background-color: var(--df-messenger-chat-background-color);
          }
          
          div.chat-min df-messenger-titlebar {
            display: none;
          }
          
          div.chat-min df-messenger-user-input {
            display: none;
          }
          
          df-message-list {
            background-color: #fafafa;
                background-color: var(--df-messenger-chat-background-color);
                display: flex;
                flex-direction: column;
                flex: 1 1 auto;
                min-height: 0;
                min-width: 250px;
          }
          
          df-messenger-titlebar {
            z-index: 2;
          }
          
          @media screen and (max-width: 500px),  
          screen and (max-height: 600px) {
          div.chat-wrapper {
            bottom: 0;       
                  right: 0;
                  width: 100%;
          }
          
          div.chat-wrapper[opened="true"] {
            height: 100%;
          }
          
          }
      `;
      }
    });
  });
});
